#define STDC_HEADERS
#include <qapp.h>
#include <stdio.h>
#include <stdlib.h>
#include <kapp.h>
#include <qlabel.h>
#include <ktopwidget.h>

class Hello : public KTopLevelWidget 
{
public:
  Hello( QWidget *parent = 0, const char *name = 0);
  setString(const char *string);
  const char *getString(void);
private:
  QLabel *label;
} ;

Hello::Hello( QWidget *, const char *name) 
 : KTopLevelWidget ( name)
{
  label = new QLabel(this);
}

Hello::setString( const char *string) {
  label->setText(string);
  label->adjustSize();
  adjustSize();
}

const char *Hello::getString(void) {
  return label->text();
}

main( int argc, char ** argv) {
  KApplication *hello;
  hello = new KApplication (argc, argv, "hello");
  Hello *t = new Hello();
  if (argc <= 1) {
    t->setString("Huhu");
  } else {
    t->setString(argv[1]);
  }
  KConfig *conf = hello->getConfig();
  conf->setGroup("Hello");
  if (conf->hasKey("text")) {
    t->setString(t->getString() + conf->readEntry("text"));
  }
  t->show();
  return hello->exec();
}
