#include "hello.moc"

Hello::Hello( QWidget *, const char *name) 
 : KTopLevelWidget ( name)
{
  label = new QLabel(this);
  KDNDDropZone *dropZone = new KDNDDropZone( this, DndURL );
  connect( dropZone, SIGNAL( dropAction( KDNDDropZone *) ),
               this, SLOT( dropEvent( KDNDDropZone *) ) );
  kfmConnection = NULL;
}

Hello::setString( const char *string) {
  label->setText(string);
  label->adjustSize();
  adjustSize();
}

const char *Hello::getString(void) {
  return label->text();
}

void Hello::dropEvent(KDNDDropZone *dropZone) {
  QString dropped = dropZone->getData();
  getFile(dropped);
}

void Hello::getFile(QString name) {
  name.detach();
  KURL u(name.data());
  if (strcmp(u.protocol(), "file") == 0) 
    showSize(u.path(), u.path());
  else {
    KFM *kfmConnection = new KFM;
    url = u.path();
    connect( kfmConnection, SIGNAL( finished() ), 
	     this, SLOT( slotKFMJobDone() ) );
    kfmConnection->copy(name.data(),"file:/tmp/localfile");
  }
}

void Hello::slotKFMJobDone() {
  delete kfmConnection;
  kfmConnection = 0;
  showSize("/tmp/localfile", url);
  unlink("/tmp/localfile");
}

void Hello::showSize(const char *file, const char *name) {
  QFile q = QFile(file);
  QString size;
  size.setNum(q.size());
  size = QString(name) + " hat " + size + " Bytes.";
  setString(size);
}

main( int argc, char ** argv) {
  KApplication *hello;
  hello = new KApplication (argc, argv, "hello");
  Hello *t = new Hello();
  if (argc <= 1) {
    t->setString("Huhu");
  } else {
    t->setString(argv[1]);
  }
  KConfig *conf = hello->getConfig();
  conf->setGroup("Hello");
  if (conf->hasKey("url")) {
    t->getFile(conf->readEntry("url"));
  }
  t->show();
  return hello->exec();
}
